// App.cpp : Defines the entry point for the application.
//


#include "..\..\DuiLib\UIlib.h"
#include "DuiDefine.h"
#include "EmbeddedDUIInMFCWindow.h"
#include "FontTypeDropWnd.h"
#include <mmsystem.h>

const TCHAR* const DUI_MSGTYPE_FONT_COLOR_SELECTED = _T("colorSelected");
const TCHAR* const DUI_MSGTYPE_FONT_SIZE_SELECTED = _T("sizeSelected");
const TCHAR* const DUI_MSGTYPE_FONT_FACE_SELECTED = _T("faceSelected");

BOOL CALLBACK FD_EnumFontProc(LPLOGFONT lplf, LPTEXTMETRIC lptm, DWORD dwType, LPARAM lpData);


class CNFontWnd : public WindowImplBase
{
    DUI_DECLARE_MESSAGE_MAP()
    DUI_DECLARE_CUSTOM_MSG_MAP()
public:
	CNFontWnd(CHARFORMAT2 charFormatInfo, CWnd* parentWnd) ;
	~CNFontWnd();
	LPCTSTR GetWindowClassName() const { return _T("NFontWnd"); };
	UINT GetClassStyle() const { return UI_CLASSSTYLE_DIALOG; };

	virtual CDuiString GetSkinFile(){
		return _T("FontWnd.xml");
	};
	virtual CDuiString GetSkinFolder(){
		return _T("skin\\nTalkRes");
	};

	virtual LRESULT OnKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	virtual LRESULT OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//	virtual LRESULT OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	CControlUI* CreateControl(LPCTSTR pstrClass);

	void InitWindow() ;

	//LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, bool& bHandled);

	void SetClientRect(CRect rc)
	{
		CRect m_rcClient = rc;
		SetWindowPos(GetHWND(), HWND_TOP, m_rcClient.left, m_rcClient.top, m_rcClient.Width(), m_rcClient.Height(), SWP_FRAMECHANGED | SWP_HIDEWINDOW);
		ShowWindow(true,true);
	};
	void SetSelectedFontOption(CButtonUI *pControl,BOOL selected);
	void InitControl();
	void GetCharFormat(CHARFORMAT2& cf) ;
	void AddFont(LPCTSTR pStrFontName, int nSize=10, bool bBold=false, bool bUnderline=false, bool bItalic=false);
	int GetFontIndex(LPCTSTR pStrFontName, int nSize=10, bool bBold=false, bool bUnderline=false, bool bItalic=false);
	void OnClose();
	int FindFaceIndex(CDuiString valueToFind);
	int FindSizeIndex(int valueToFind);
	void UpdateFontData();
	CDuiString GetFaceName();
	LONG GetSize();
	void UpdateSampleText();
	int FindColorIndex(COLORREF valueToFind);
	void OnFinalMessage(HWND hWnd);
public:
	CFontFaceDropWnd *m_pFaceDropWnd;
	CFontSizeDropWnd *m_pSizeDropWnd;
	//CFontColorDropWnd *m_pColorDropWnd;

	CButtonUI* m_pBtnFace;
	CButtonUI* m_pBtnSize;
	CButtonUI* m_pBtnColor;

	COptionUI *m_pBtnLine0;
	COptionUI *m_pBtnLine1;
	COptionUI *m_pBtnLine2;
	COptionUI* m_pBtnBold;	
	COptionUI* m_pBtnIta;
	COptionUI* m_pBtnUnderline;
	COptionUI* m_pBtnStrike;
   
	CButtonUI* m_pBtnOk;
	CButtonUI* m_pBtnCancel;
	CLabelUI* m_pLabelTitle;
    CRichEditUI* m_pSampleText;
	vector<CDuiString> m_vecface;
	static int   m_size[];
	static DWORD ms_pColors[];

	CHARFORMAT2 m_cf;
    CWnd* m_pParentChatWnd;

	int m_FaceSelIndex;
	int m_ColorSelIndex;
	int m_SizeSelIndex;
	bool m_childCreate;

private:
    void _OnNotifyCloseBtnClick(TNotifyUI& msg);
    void _OnNotifyBtnOkClick(TNotifyUI& msg);
    void _OnNotifyBtnCancelClick(TNotifyUI& msg);
    void _OnNotifyBtnFontSizeClick(TNotifyUI& msg);
    void _OnNotifyBtnFontType(TNotifyUI& msg);
    void _OnNotifyBtnFontColorClick(TNotifyUI& msg);
    void _OnNotifyBtnPropertyClick(TNotifyUI& msg);
    void _OnNotifyColorSelected(TNotifyUI& msg);
    void _OnNotifySizeSelected(TNotifyUI& msg);
    void _OnNotifyFaceSelected(TNotifyUI& msg);
};